> For the complete documentation index, see [llms.txt](https://docs.nosto.com/ugc/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nosto.com/ugc/api-docs/javascript.md).

# JavaScript API

Nosto allows customers to customize Widgets and Digital Screen features via JavaScript and CSS. Customers can interface with either the markup or rendering aspects via hooks and events, or our activities APIs such as voting and commenting.

### Widgets

Straight out of the box, Widgets are available in a variety of layouts and can have their displays customized when configured.

Nosto's UGC Widgets can further be customized to modify their look and feel, as well as their behavior. By hooking into events (e.g. the rendering of a widget, voting, commenting, expanded-tile viewing, tracking) developers can both receive callbacks as well as provide data and markup to augment. Further events can be added by developers and frameworks such as jQuery can be utilised if needed.

[UGC Widgets](/ugc/api-docs/rest/reference/widgets.md)

### Digital Screens

Nosto's UGC Screens feature a full templating framework, as well as custom HTML, JavaScript, and CSS capabilities for developers to add their layouts, transition, data management and so much more.

[UGC Digital Screens](broken://pages/dLRvxvNIwoYdDagnCeBL)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nosto.com/ugc/api-docs/javascript.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
